#ifndef _NES_ONLY


#include <ddraw.h>
#include "win32_GB_screen_mgr.h"
#include "win32_GUID.h"

win32_GB_screen_mgr::win32_GB_screen_mgr(HWND window_handle)
{
	wnd_handle = window_handle;
	screen     = NULL;
	fullscreen = FALSE;

	if(!GoWindowed())
	{
		throw "Error initializing win32 windowed screen manager";
	}
}

win32_GB_screen_mgr::~win32_GB_screen_mgr()
{
	if(screen)
		delete screen;
}

boolean win32_GB_screen_mgr::lock(pixmap& p)
{
	return screen->lock(p);
}

boolean win32_GB_screen_mgr::unlock()
{
	return screen->unlock();
}

void win32_GB_screen_mgr::blt()
{
	screen->blt();
}

void win32_GB_screen_mgr::flip()
{
	screen->flip();
}

void win32_GB_screen_mgr::clear(PIXEL color)
{
	screen->clear(color);
}
/*
boolean win32_GB_screen_mgr::set_palette(const uint8 pal[256][3])
{
	return screen->set_palette(pal);
}

boolean win32_GB_screen_mgr::get_palette(uint8 pal[256][3])
{
	return screen->get_palette(pal);
}

boolean win32_GB_screen_mgr::set_palette_section(uint8 start, uint8 len, const uint8 pal[][3])
{
	return screen->set_palette_section(start, len, pal);
}

boolean win32_GB_screen_mgr::get_palette_section(uint8 start, uint8 len, uint8 pal[][3])
{
	return screen->get_palette_section(start, len, pal);
}

void win32_GB_screen_mgr::assert_palette()
{
	set_NES_palette();
	screen->assert_palette();
}
*/
void win32_GB_screen_mgr::shot_screen( char *szFileName )
{
	screen->shot_screen( szFileName );
}



boolean win32_GB_screen_mgr::toggle_fullscreen()
{
	if(fullscreen)
		return GoWindowed();
	else
		return GoFullscreen();
}
boolean win32_GB_screen_mgr::GoWindowed()
{
	GB_screen_mgr* sm;


	try {
/*		
		if(NESTER_settings.nes.graphics.WindowModeUseDdraw){
			if(screen)
				delete screen;
			sm = new win32_overlaywindowed_GB_screen_mgr(wnd_handle);
		}
		else
*/
		{			
			sm = new win32_windowed_GB_screen_mgr(wnd_handle);
			if(screen)
				delete screen;
		}
	} catch(const char* IFDEBUG(s)) {
		LOG(s << endl);
		return FALSE;
	} catch(...) {
		return FALSE;
	}

	//  if(screen)
	//    delete screen;
	screen = sm;
	fullscreen = FALSE;
	return TRUE;
}

boolean win32_GB_screen_mgr::GoFullscreen()
{
	return 0;
	GB_screen_mgr* sm;

	try {
//		sm = new win32_fullscreen_GB_screen_mgr(wnd_handle,
//		        GetGUIDPtr(&NESTER_settings.nes.graphics.osd.device_GUID),
//		        NESTER_settings.nes.graphics.fullscreen_scaling);
	} catch(const char* IFDEBUG(s)) {
		LOG(s << endl);
		return FALSE;
	} catch(...) {
		return FALSE;
	}

	if(screen)
		delete screen;
	screen = sm;
	fullscreen = TRUE;
	return TRUE;
}

void win32_GB_screen_mgr::SetScreenmgr(){
	GB_screen_mgr* sm;
	if(screen){
		delete screen;
		screen=NULL;
		if(fullscreen)
			Sleep(300);
	}
	try {
		if(fullscreen){
//			sm = new win32_nnnfullscreen_GB_screen_mgr(wnd_handle,GetGUIDPtr(&NESTER_settings.nes.graphics.osd.device_GUID),
//			        NESTER_settings.nes.graphics.fullscreen_scaling);
		}
		else{
/*			
			if(NESTER_settings.nes.graphics.WindowModeUseDdraw){
				sm = new win32_overlaywindowed_GB_screen_mgr(wnd_handle);
			}
			else
*/
			{
				sm = new win32_windowed_GB_screen_mgr(wnd_handle);
			}
		}
	} catch(const char* IFDEBUG(s)) {
		LOG(s << endl);
		return;
	} catch(...) {
		return;
	}
	screen = sm;
	return;
}
#if 0

#endif

void win32_GB_screen_mgr::nnnManuEnable(unsigned char flag){
	screen->nnnManuEnable(flag);
}


void win32_GB_screen_mgr::EndEmu(){
	screen->EndEmu();
}


void win32_GB_screen_mgr::StartEmu(){
	screen->StartEmu();
}




/*
void win32_GB_screen_mgr::set_screenmode(unsigned char sm)
{
	if(ScreenMode != sm){
		ScreenMode = sm;
		screen->set_screenmode(sm);
	}
}
*/

#endif
